'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : Stijn Coenen (Elektronicastynus.be)               *
'*  Notice  : Copyright (c) 2014 Stijn Coenen                   *
'*          : All Rights Reserved                               *
'*  Date    : 25/03/2014                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device 18F452
    Config_Start
      OSC = HSPLL	;HS oscillator with PLL enabled/Clock frequency = (4 x FOSC)
      OSCS = OFF	;Oscillator system clock switch option is disabled (main oscillator is source)
      PWRT = OFF	;PWRT disabled
      BOR = OFF	;Brown-out Reset disabled
      BORV = 20	;VBOR set to 2.0V
      WDT = OFF	;WDT disabled (control is placed on the SWDTEN bit)
      WDTPS = 128	;1:128
      CCP2MUX = On	;CCP2 input/output is multiplexed with RC1
      STVR = OFF	;Stack Full/Underflow will cause RESET
      LVP = OFF	;Low Voltage ICSP disabled
      Debug = OFF	;Background Debugger disabled. RB6 and RB7 configured as general purpose I/O pins.
      Cp0 = OFF	;Block 0 (000200-001FFFh) not code protected
      CP1 = OFF	;Block 1 (002000-003FFFh) not code protected
      CP2 = OFF	;Block 2 (004000-005FFFh) not code protected
      CP3 = OFF	;Block 3 (006000-007FFFh) not code protected
      CPB = OFF	;Boot Block (000000-0001FFh) not code protected
      CPD = OFF	;Data EEPROM not code protected
      WRT0 = OFF	;Block 0 (000200-001FFFh) not write protected
      WRT1 = OFF	;Block 1 (002000-003FFFh) not write protected
      WRT2 = OFF	;Block 2 (004000-005FFFh) not write protected
      WRT3 = OFF	;Block 3 (006000-007FFFh) not write protected
      WRTC = OFF	;Configuration registers (300000-3000FFh) not write protected
      WRTB = OFF	;Boot Block (000000-0001FFh) not write protected
      WRTD = OFF	;Data EEPROM not write protected
      EBTR0 = OFF	;Block 0 (000200-001FFFh) not protected from Table Reads executed in other blocks
      EBTR1 = OFF	;Block 1 (002000-003FFFh) not protected from Table Reads executed in other blocks
      EBTR2 = OFF	;Block 2 (004000-005FFFh) not protected from Table Reads executed in other blocks
      EBTR3 = OFF	;Block 3 (006000-007FFFh) not protected from Table Reads executed in other blocks
      EBTRB = OFF	;Boot Block (000000-0001FFh) not protected from Table Reads executed in other blocks
    Config_End 
          
    Xtal                     = 40
    
    All_Digital              = true  
      
    Symbol    KnipEnd        = PORTC.6    'PORTC.7
    Symbol    Btn_L          = $A    
    Symbol    Btn_Esc        = $E  
    Symbol    Btn_Ent        = $F          
    Symbol    Btn_R          = $B     
    Symbol    Btn_Up         = $C  
    Symbol    Btn_Dwn        = $D
    Declare   PortB_Pullups    1
'    Symbol    Aan            = 0
 '   Symbol    Uit            = 1
    Dim       Dwn_Bit        As Bit
    Dim       L_Bit          As Bit
    Dim       Ent_Bit        As Bit
    Dim       R_Bit          As Bit
    Dim       Up_Bit         As Bit
                              
    Symbol    HB_PWM2        = LATC.1                     
    Symbol    HB_PWM1        = LATC.2
    Symbol    HB_FCCM1       = LATC.3
    Symbol    HB_FCCM2       = LATC.4
                                        
    Declare   CCP1_Pin       LATC.2     
    Declare   CCP2_Pin       LATC.1
    
    Declare   LCD_DTPin        LATD.4  
    Declare   LCD_ENPin        LATD.3 
    Declare   LCD_RSPin        LATD.2   
    Declare   LCD_Interface    4
    Declare   LCD_Lines        2      
    
    Symbol    ST_Step       = LATE.1   
    Symbol    ST_Dir        = LATE.2
        
    TRISA = 255            
    TRISB                    = 255
    TRISC                    = %11000000        
    TRISD                    = 0
    TRISE                    = 0
    'Menu Main:    
    Dim       MainMenuIndex   As Byte 
    
    'Draad Menu: 
    Dim       DraadMenuIndex  As Byte  
    Dim       DraadMenuDeca   As Byte 
        
    Dim       DraadLengte     As Word
    Dim       DraadAantal     As Word
    Dim       DraadOprollen   As Bit
    Dim       DraadRolLinks   As Word
    Dim       DraadRolRechts  As Word
    Dim       DraadTemp       As Word
    
    Dim       PulsAantal      As Dword  
    
    'Knippen:
    Dim       PWM_Snelheid    As Byte  
    Dim       PWM_Max_Snel    As Byte
    
    'Afmeten
    Dim       PulsPermm       As Word
        
    'Oprollen:
    Dim       PulsPerom       As Word  
   
    'Menu Instellingen: 
    Dim       InstMenuIndex   As Byte  
    Dim       InstMenuDeca    As Byte 
    Dim       InstTemp        As Word

    Symbol    EE_PulsPerMM    = 0 'word
    Symbol    EE_PulsPerOm    = 4 'word
    
    
    Dim StepOn       As Byte
    Dim StepSpeedSet As Byte
    Dim StepSpeedRamp As Byte
    Dim stepPreload     As Word 
    Dim stepPreloadMax     As Word
    Dim StepBusy      As Bit
    
    
        Dim dir_mem As Bit
        Dim KnopMove As Bit
    
Clear   
    
'****************************************************************
Init:
    'PWM Max snelheid:
    PWM_Max_Snel = 200          
    PulsPermm = 309 '308 ' 305
    
  '  PulsPermm = ERead EE_PulsPerMM  
      
    
    HB_FCCM1 = 1
    HB_FCCM2 = 1
    Cls 
    DelayMS 100    '1234567890123456
    Print At 1, 1, " E-Stynus 2015  "
    Print At 2, 1, "Draadknipper V2 "
    DelayMS 750
    Cls
    GoSub Tang_Open
    
    TRISB = %00001111
    Dim knop As Byte
    Dim tempknop As Byte
    
    'Timer0
    T0CON	 = $82
    TMR0H	 = $0B
    TMR0L	 = $DC
    INTCON.7 = 1
    INTCON.5 = 1
    
    'Timer1
    T1CON	 = $01
    PIE1.0 = 1       
    INTCON.6 = 1
    
    'TMR1IF_bit	 = 0
   ' TMR1H	 = 0xFF
   ' TMR1L	 = 0xEC
    'INTCON	 = 0xC0
       
    GoTo Main
'****************************************************************
Main:   
While 1 = 1
    Select MainMenuIndex
       Case 0              '1234567890123456
            Print At 1, 1, ">Draad knippen  " 
            Print At 2, 1, " Instellingen   "
       Case 1                              
            Print At 1, 1, ">Instellingen   "    
            Print At 2, 1, " Test Modus     "
       Case 2                         
            Print At 1, 1, ">Test Modus     "
            Print At 2, 1, " Draad knippen  "    
       Case Else
            MainMenuIndex = 0
    EndSelect
    
    If knop = Btn_Dwn Then 
       If Dwn_Bit = 0 Then       
           If MainMenuIndex < 2 Then
              Inc MainMenuIndex   
           Else
              MainMenuIndex = 0
           EndIf             
       EndIf  
       DelayMS 100   
       Dwn_Bit = 1       
    Else 
       Dwn_Bit = 0
    EndIf   
    
    If knop = Btn_Up Then 
       If Up_Bit = 0 Then       
           If MainMenuIndex > 0 Then
              Dec MainMenuIndex   
           Else
              MainMenuIndex = 2
           EndIf             
       EndIf  
       DelayMS 100   
       Up_Bit = 1       
    Else 
       Up_Bit = 0
    EndIf     
    
    If knop = Btn_Ent Then   
        Ent_Bit = 1
        While knop = Btn_Ent
        Wend
        Select MainMenuIndex
           Case 0          
                GoSub DraadMenu 
           Case 1                              
                'GoSub Instellingen
           Case 2                         
                GoSub TestMenu 
           Case Else
                MainMenuIndex = 0
        EndSelect
    
    EndIf  
  
Wend  
On_Hardware_Interrupt GoTo Interr
Interr:
    Context Save  
    If INTCON.2 = 1 Then
        INTCON.2 = 0    
        TMR0H	 = $0B;
        TMR0L	 = $DC;

        knop = $10 
        LATB = %11100000   
        If (PORTB & $0F) < $0F Then
            tempknop = ~PORTB & $0F
            Select tempknop
                Case 1
                    knop = $D  
                Case 2
                    knop = $C
                Case 4
                    knop = $B
                Case 8
                    knop = $A
            EndSelect                
        EndIf   
        LATB = %11010000
        If (PORTB & $0F) < $0F Then 
            tempknop = ~PORTB & $0F
            Select tempknop
                Case 1
                    knop = $F  
                Case 2
                    knop = 9
                Case 4
                    knop = 6
                Case 8
                    knop = 3
            EndSelect                
        
        EndIf     
        LATB = %10110000
        If (PORTB & $0F) < $0F Then
            tempknop = ~PORTB & $0F
            Select tempknop
                Case 1
                    knop = 0 
                Case 2
                    knop = 8
                Case 4
                    knop = 5
                Case 8
                    knop = 2
            EndSelect                
        
        EndIf
        LATB = %01110000
        If (PORTB & $0F) < $0F Then  
            tempknop = ~PORTB & $0F
            Select tempknop
                Case 1
                    knop = $E 
                Case 2
                    knop = 7
                Case 4
                    knop = 4
                Case 8
                    knop = 1
            EndSelect                
        
        EndIf 
        
        'Stepper move 
        If StepBusy = 0 Then  
            If knop = 10 Then
                KnopMove = 1
                ST_Dir = 0
                StepSpeedSet = 1
                StepSpeedRamp = 10
                StepOn  = 1              
            EndIf    
            If knop = 11 Then 
                KnopMove = 1
                ST_Dir = 1
                StepSpeedSet = 1    
                StepSpeedRamp = 10
                StepOn  = 1           
            EndIf
        EndIf
        If knop = 16 Then
            If KnopMove = 1 Then 
                StepOn  = 0
                KnopMove = 0
            EndIf
        EndIf  
   
    EndIf
    
    'Timer 1 stepper interrupt
    
    If PIR1.0 = 1 Then
        PIR1.0 = 0
'        2S
'        TMR1H	 = 0xFF
'        TMR1L	 = 0xEC
'        65516
'        300S
'        TMR1H    = $F4
 '       TMR1L	 = $48
'        62536

        TMR1H = stepPreload.HighByte  
        TMR1L = stepPreload.LowByte
        
        Symbol stepper_tmr_min = 62000
        If stepPreload < (stepper_tmr_min + (8 * StepSpeedSet)) Then      '9
            stepPreload = stepPreload + StepSpeedRamp 
        EndIf      

        
        If StepOn = 1 Then
            If ST_Step = 0 Then
                If KnopMove = 1 Or PulsAantal > 0 Then 
                    ST_Step = 1
                EndIf
            Else
                ST_Step = 0
                If KnopMove = 0 Then
                    Dec PulsAantal 
                EndIf
            EndIf
        Else
            StepSpeedRamp = 0   
            stepPreload = stepper_tmr_min
        EndIf

    EndIf


    Context Restore
'****************************************************************     
'Include "DraadMenu.bas"
'****************************************************************
'Include "InstelMenu.bas"
'****************************************************************
TestMenu:
   
Return
'****************************************************************
Knip:              
    GoSub Tang_Open
    DelayMS 500       
    GoSub Tang_Dicht  
    DelayMS 500    
    GoSub Tang_Open      
Return                                    
'****************************************************************
Tang_Open:
    HPWM 1, 127, 20000 
    While KnipEnd = 1 
    Wend    
    HPWM 1,   0, 20000 
Return                 
'****************************************************************
Tang_Dicht:
    PWM_Snelheid = 100
    HPWM 1,   PWM_Snelheid, 20000   
    While KnipEnd = 0
    Wend        
    While KnipEnd = 1     
          HPWM 1, PWM_Snelheid, 20000   
          If PWM_Snelheid < PWM_Max_Snel Then
             Inc PWM_Snelheid
          EndIf
          DelayMS 10  
    Wend            
    HPWM 1,   0, 20000 
Return      
'****************************************************************
Tang_Stop:
    HPWM 1,   0, 20000 
Return 
'****************************************************************
DraadMenu:     
    Cls            '1234567890123456
    Print At 1, 1, "Draad inst."
    
    'Lengte:
    DraadMenuDeca  = 0
    DraadMenuIndex = 0
    DraadTemp = 0
    
Dim knoptemp As Byte

    While 1 = 1        '1234567890123456
        
        Select DraadMenuIndex 
           Case 0
                Print At 2, 1, "Lengte:  ", Dec DraadTemp ," mm    " 
           Case 1      
                Print At 2, 1, "Aantal:  ", Dec DraadTemp ,"       "            
        EndSelect
               
        If knop = $E Then 
            DraadTemp = 0
        EndIf
        
        If knop < 10 Then
            knoptemp = knop 
            
            If DraadTemp < 9999 Then
                If DraadTemp > 0 Then
                    DraadTemp = DraadTemp * 10
                EndIf 
                DraadTemp = DraadTemp + knoptemp  
            EndIf
            DelayMS 100
            While knoptemp = knop
            Wend      

        EndIf
        
        DelayMS 200  
        
        If knop = Btn_Ent Then 
           If Ent_Bit = 0 Then   
              Select DraadMenuIndex
                  Case 0
                       DraadLengte = DraadTemp    
                       DraadMenuDeca  = 0
                       DraadTemp = 0
                  Case 1       
                       DraadAantal = DraadTemp  
                       DelayMS 100   
                       Break   
              EndSelect      
           EndIf      
           Inc DraadMenuIndex
           DelayMS 100   
           Ent_Bit = 1       
        Else 
           Ent_Bit = 0
        EndIf  
        
        
    Wend
    
    DraadOprollen = 0
    If DraadLengte > 499 Then
      '  Print $FE, $0C 'Cursor off
                       '1234567890123456
        Print At 2, 1, "Oprollen?   Ja  " 
        While 1 = 1
            If DraadOprollen = 1 Then
               Print At 2, 12, " Ja"  
            Else                     
               Print At 2, 12, "Nee"          
            EndIf
            
             If knop = Btn_Dwn Then 
               If R_Bit = 0 Then       
                   DraadOprollen = 1         
               EndIf  
               DelayMS 100   
               R_Bit = 1       
            Else 
               R_Bit = 0
            EndIf    
            
            If knop = Btn_Up Then 
               If L_Bit = 0 Then      
                   DraadOprollen = 0
               EndIf  
               DelayMS 100   
               L_Bit = 1       
            Else 
               L_Bit = 0
            EndIf    
            
            DelayMS 200    
            
            If knop = Btn_Ent Then 
               If Ent_Bit = 0 Then   
                  DelayMS 100   
                  Break    
               EndIf      
               DelayMS 100   
               Ent_Bit = 1       
            Else 
               Ent_Bit = 0
            EndIf  
            
        Wend
    EndIf
    
    Cls
                   '1234567890123456
    Print At 1, 1, "Starten?        " 
    Print At 2, 1, Dec DraadAantal, " x ", Dec DraadLengte, " mm  " 
    
    While 1 = 1
       
        DelayMS 200    
        
        If knop = Btn_Ent Then 
           If Ent_Bit = 0 Then   
              DelayMS 100   
              Break    
           EndIf      
           DelayMS 100   
           Ent_Bit = 1       
        Else 
           Ent_Bit = 0
        EndIf  
                                 
        If knop = Btn_Esc Then 
            Return
            DelayMS 100   
        EndIf  
        
    Wend
    
    Cls
    Print At 1,1, "Knippen"
    
    DelayMS 1000
    
    While DraadAantal > 0
                       '1234567890123456
        Print At 1, 1, "Knippen "
        Print At 2, 1, "Rest: ", Dec4 DraadAantal
    
        PulsAantal = DraadLengte * PulsPermm / 10
        
        'Stappenmotor draad bewegen    
        ST_Dir = 1
        Dim delaytijd As Word
        delaytijd = 200' 500
        
        ST_Dir = 1
        StepSpeedSet = 100 
        StepSpeedRamp = 10
        StepOn  = 1    
        
        While PulsAantal > 0 
            If DraadOprollen = 1 Then
                If PulsAantal < ((DraadLengte - 215) * PulsPermm / 10)  Then
                    HPWM 2,   45, 20000      
                EndIf
            EndIf
            Print At 1,10, Dec6 PulsAantal / PulsPermm  
            DelayMS 200               
        Wend 
   
        If knop = Btn_Esc Then    
            Break    
        EndIf  
        
        HPWM 2,   0, 20000     
        
        GoSub Knip 
        
        If DraadOprollen = 1 Then
            HPWM 2,   45, 20000 
            DelayMS 2000   
            HPWM 2,   0, 20000 
            Cls 
            If DraadAantal > 1 Then         
                Print At 1, 1, "Opnieuw Starten?"
                While knop <> Btn_Ent               
                Wend   
            EndIf     
        EndIf
        
        Dec DraadAantal   
        
    Wend
    
    Cls            '1234567890123456
    Print At 1, 1, "     Klaar!     "
  
    While 1 = 1
        If knop = Btn_Ent  Then   
           DelayMS 100 
           While knop = Btn_Ent
           Wend      
           Ent_Bit = 1 
           Return 
        EndIf  
    Wend

Return
End  
'****************************************************************

